/*************************
      "Music Teacher"
      Stamati Daniela
          331CC
************************/








#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <iom324.h>
#include <unistd.h>

#define ERR_FQ 10;

uint8_t led[] = {
  PA0, PA1, PA2, PA3, PA4, PA5, PA6, PA7};
uint8_t but[] = {
  PC0, PC1, PC2, PC3, PC4, PC5, PC6, PC7};
  
  
struct nota{
   int nota;
   int del; //delay (it defines how much the note will play in ms)
};

unsigned int freq[8] = 
{
  /*DO   RE   MI   FA   SOL  LA   SI   DO*/
  59, 63, 70, 79, 89, 94, 106, 119
};


/* function which allows the user to play a single note*/
int play (){

  int i, pressed = 0;
  int note = -1;
  
  while(1) {
    pressed = 0;
    for(i = 0; i < 8; i++) {
      
      /* check which button is pressed*/
      if(!(PINC & _BV(but[i]))) {
        pressed = 1;
        PORTA |= _BV(led[i]);
          /*play  note*/
          TCCR1A |= _BV(COM1A0);
          OCR1A = freq[i];
          note = i;

      } 
      else {
          /* if button i is not pressed, make sure the corresponding led is not litten */
          PORTA &= ~_BV(led[i]);
       }
     }
     
     if(!pressed){
          /* mute the buzzer */
          TCCR1A &= ~_BV(COM1A0);
     }else{ //a key was pressed
        /* play note for half a second */
       _delay_ms(500);
       /* mute the buzzer */
       TCCR1A &= ~_BV(COM1A0);
       /*turn off the led*/
       PORTA &= ~_BV(led[note]);
       /*return the played node */
       return note;
     }
 
  }

}

void HappyBirthday() {

  int i;
  int progress = 0;
  int OK = 0;
  int finished = 0;
  
       /* register the song */
       struct nota *HB = malloc(15*sizeof(struct nota));
       
       HB[0].nota = 8-4;
       HB[0].del = 700;
       
       HB[1].nota = 8-4;
       HB[1].del = 700;
       
       HB[2].nota = 8-5;
       HB[2].del = 700;
       
       HB[3].nota = 8-4;
       HB[3].del = 700;
       
       HB[4].nota = 8-6;
       HB[4].del = 700;
       
       HB[5].nota = 8-5;
       HB[5].del = 1000;
       /**********************/
       
     
     while (!finished){
         
       OK = 1;
       _delay_ms(500);
       
       /* play a note block of size progress */
       for (i = 0; i<=progress; i++){
             PORTA |= _BV(led[HB[i].nota]);         
             TCCR1A |= _BV(COM1A0);
             OCR1A = freq[led[HB[i].nota]];
           
             _delay_ms(HB[i].del);
             
             PORTA &= ~_BV(led[HB[i].nota]);         
             TCCR1A &= ~_BV(COM1A0);
             
             _delay_ms(250);
             
         }
         
         _delay_ms(500);
         
         /* request the user to play the notes previously played */
         for(i = 0; i<=progress; i++)
           if(play() != HB[i].nota){
             
               TCCR1A |= _BV(COM1A0);
               OCR1A = ERR_FQ;
               OK = 0;
             
               _delay_ms(800);
               break;
               
             }
         
         /* the sequence was  correctly reproduced, increase the block size */
         if(OK){
           
             /* play the "good job" sound :) */
             for(i = 7; i>=0; i--){
                 PORTA |= _BV(led[i]);         
                 TCCR1A |= _BV(COM1A0);
                 OCR1A = freq[i];
               
                 _delay_ms(100);
                 
                 PORTA &= ~_BV(led[i]);         
                 TCCR1A &= ~_BV(COM1A0);
             }
             
             progress++;
         }
         if(progress == 6)
           finished = 1;
         
       }

}




int main(){
  DDRA = 0xFF;
  DDRC = 0x00;
  PORTC = 0xFF;
  

  //set PD5 as putput
  DDRD = _BV(PD5);		
  TCCR1A |= _BV(WGM10)|_BV(COM1A0); 
  TCCR1B |= _BV(WGM13) | _BV(CS12);
  
 // play();
  HappyBirthday();
  return 0;
}


